package com.serialio.sdm_tcpip_client.data.repository.sdm_device

import com.serialio.sdm_tcpip_client.data.repository.sdm_device.model.SdmDevice
import com.serialio.sdm_tcpip_client.domain.repository.SdmDeviceRepository
import kotlinx.coroutines.delay
import kotlinx.coroutines.flow.Flow
import kotlinx.coroutines.flow.flow

class SdmDeviceRepositoryImp : SdmDeviceRepository {
    var list = mutableListOf<SdmDevice>()
    private var bUpdate: Boolean = true

    override suspend fun addDevice(device: SdmDevice) {
        list.add(device)
        updateClintFlow()
    }

    override suspend fun addDevices(devices: List<SdmDevice>) {
        list.addAll(devices)
        updateClintFlow()
    }

    override suspend fun updateStatus(deviceID: String, status: String) {
        val devices = list.find { it.deviceId == deviceID }
        devices?.let {
            devices.status = status
        }
        updateClintFlow()
    }

    override suspend fun clearDevices() {
        list.clear()
        updateClintFlow()
    }

    private fun updateClintFlow() {
        bUpdate = true
    }

    override suspend fun getDevices(): Flow<List<SdmDevice>> {
        bUpdate = true
        return flow {
            while (true) {
                if(bUpdate) {
                    emit(list)
                    bUpdate = false
                }
                delay(100)
            }
        }
    }
}
