package com.serialio.sdm_tcpip_client.data.tcp_protocol

import com.google.gson.Gson
import com.serialio.sdm_tcpip_client.data.tcp_protocol.model_request_dto.ParametersRequestTcp
import com.serialio.sdm_tcpip_client.data.tcp_protocol.model_request_dto.RequestItemTcp

/**
 * Created by Mykola Blyzniuk on 09.07.2022.
 */

fun makeClientIdentificationRequest(request_id: Int, client_id: String, password: String): String {
    val clienIdentifReqest = RequestItemTcp(request_id, client_id, ConstantsTcp.CMD_CLIENT_IDENTIFICATION,
        ParametersRequestTcp(password = password))
    return Gson().toJson(clienIdentifReqest)
}

fun makeRemoteDeviceListRequest(request_id: Int, client_id: String): String {
    val deviceListReqest = RequestItemTcp(request_id, client_id, ConstantsTcp.CMD_GET_REMOTE_DEVICES)
    return Gson().toJson(deviceListReqest)
}

fun makeDeviceConnectRequest(request_id: Int, client_id: String, device_id: String, connect_disconnect: String): String {
    val deviceListReqest = RequestItemTcp(request_id, client_id, ConstantsTcp.CMD_DEVICE_CONNECT,
        ParametersRequestTcp(device_id = device_id, connect_disconnect = connect_disconnect))
    return Gson().toJson(deviceListReqest)
}

fun makeDeviceCommandRequest(request_id: Int, client_id: String, device_id: String, command_name: String): String {
    val deviceCommandResponse = RequestItemTcp(request_id, client_id, ConstantsTcp.CMD_DEVICE_COMMAND,
        ParametersRequestTcp(device_id = device_id, command_name = command_name))
    return Gson().toJson(deviceCommandResponse)
}

