package com.serialio.sdm_tcpip_client.data.tcp_protocol

import com.google.gson.Gson
import com.google.gson.reflect.TypeToken
import com.serialio.sdm_tcpip_client.data.tcp_protocol.model_request_dto.RequestItemTcp
import com.serialio.sdm_tcpip_client.data.tcp_protocol.model_response_dto.ResponseItemTcp
import org.json.JSONArray
import org.json.JSONException
import org.json.JSONObject

fun parseServerJsonData(jsonString: String): ResponseItemTcp? {
    val requestObj = object : TypeToken<ResponseItemTcp>() {}.type
    return Gson().fromJson(jsonString, requestObj)
}

fun parseClientData(jsonString: String): RequestItemTcp? {
    val requestObj = object : TypeToken<RequestItemTcp>() {}.type
    return Gson().fromJson(jsonString, requestObj)
}

fun isJSONValid(test: String?): Boolean {
    try {
        JSONObject(test)
    }
    catch (ex: JSONException) {
        try {
            JSONArray(test)
        }
        catch (ex1: JSONException) {
            return false
        }
    }
    return true
}


