package com.serialio.sdm_tcpip_client.data.tcp_protocol.model_response_dto

import com.serialio.sdm_tcpip_client.data.repository.sdm_device.model.SdmDevice
import com.serialio.sdm_tcpip_client.data.tcp_protocol.ConstantsTcp

data class RemoteDeviceResponseTcp(
    var device_id: String?,
    var device_type: String?,
    var device_name: String?,
    var device_state: String?,
    var device_commands: MutableList<DeviceCommandResponseTcp>?
){
    fun toSdmDevice(): SdmDevice {
        var device = SdmDevice(
            name = device_name ?:"name is empty",
            type = device_type ?:"type is empty",
            deviceId = device_id ?:"id is empty",
            status = device_state ?: ConstantsTcp.DEVICE_STATE_UNAVAILABLE
        )
        device.listCmds = device_commands?.map {it -> it.toSdmCommands()}
        return device
    }
}
