package com.serialio.sdm_tcpip_client.data.upd_client

import com.serialio.sdm_tcpip_client.data.upd_client.data.DataUdp
import com.serialio.sdm_tcpip_client.domain.repository.UdpRepository
import kotlinx.coroutines.Dispatchers
import kotlinx.coroutines.flow.Flow
import kotlinx.coroutines.flow.flow
import kotlinx.coroutines.flow.flowOn
import javax.inject.Inject
import javax.inject.Singleton

/**
 * Created by Mykola Blyzniuk on 29.08.2022.
 */
@Singleton
class UdpRepositoryImpl @Inject constructor(
) : UdpRepository {

    private var udpDataSource: UdpDataSource? = null

    override fun listenUdpData(
        portLocal: Int,
        portRemote: Int,
        ipLocal: String,
    ): Flow<DataUdp> =
        flow {
            udpDataSource = UdpDataSource(portLocal, portRemote, ipLocal)
            udpDataSource?.listenUDP()?.collect {
                emit(it)
            }
        }.flowOn(Dispatchers.IO)

    override suspend fun sendUdpData(ip: String, message: String) {
        udpDataSource?.sendUdpMessage(ip, message)
    }

    override suspend fun stopUdpListening(){
        return udpDataSource?.stopUdpListen()!!
    }
}

