package com.serialio.sdm_tcpip_client.di

import com.serialio.sdm_tcpip_client.data.repository.sdm_device.SdmDeviceRepositoryImp
import com.serialio.sdm_tcpip_client.data.tcp_client.TcpClientRepositoryImpl
import com.serialio.sdm_tcpip_client.data.upd_client.UdpRepositoryImpl
import com.serialio.sdm_tcpip_client.domain.repository.SdmDeviceRepository
import com.serialio.sdm_tcpip_client.domain.repository.TcpClientRepository
import com.serialio.sdm_tcpip_client.domain.repository.UdpRepository
import dagger.Module
import dagger.Provides
import dagger.hilt.InstallIn
import dagger.hilt.components.SingletonComponent
import javax.inject.Singleton

@InstallIn(SingletonComponent::class)
@Module
class Module {

    @Provides
    @Singleton
    fun provideSdmDevicesRepository(): SdmDeviceRepository {
        return SdmDeviceRepositoryImp()
    }

    @Provides
    @Singleton
    fun provideTcpClientDataSource(): TcpClientRepository {
        return TcpClientRepositoryImpl()
    }

    @Provides
    @Singleton
    fun provideUdpDataSource(): UdpRepository {
        return UdpRepositoryImpl()
    }

}
