package  com.serialio.sdm_tcpip_client.presentation.device_manager


import android.util.Log
import androidx.lifecycle.LiveData
import androidx.lifecycle.MutableLiveData
import androidx.lifecycle.ViewModel
import androidx.lifecycle.viewModelScope
import com.serialio.sdm_tcpip_client.data.repository.sdm_device.model.SdmDevice
import com.serialio.sdm_tcpip_client.domain.repository.SdmDeviceRepository
import dagger.hilt.android.lifecycle.HiltViewModel
import kotlinx.coroutines.launch
import javax.inject.Inject

@HiltViewModel
class DeviceMangerViewModel @Inject constructor(
    private val sdmDevicesUseCases: SdmDeviceRepository
) : ViewModel() {

    private val _sdmDevicesLiveData = MutableLiveData<List<SdmDevice>>()
    val sdmDevicesLiveData: LiveData<List<SdmDevice>> = _sdmDevicesLiveData

    init {
        getSdmDeices()
    }

    private fun getSdmDeices() {
        viewModelScope.launch() {
            sdmDevicesUseCases.getDevices().collect {
                Log.i("DeviceMangerViewModel", "SDM Devices ${it.size}",)
                _sdmDevicesLiveData.value = it
            }
        }
    }

}
