package com.serialio.sdm_tcpip_client.utils

import android.app.NotificationManager
import android.app.PendingIntent
import android.content.Context
import android.content.Intent
import androidx.core.app.NotificationCompat
import com.serialio.sdm_tcpip_client.*
import com.serialio.sdm_tcpip_client.presentation.main.MainActivity
import com.serialio.sdm_tcpip_client.service.SdmClientForegroundService

fun createForegroundNotificationBuilder(context: Context, notificationID: Int):  NotificationCompat.Builder {
        val intent = Intent(context, SdmClientForegroundService::class.java)

        val notificationIntent = Intent(context, MainActivity::class.java)
        notificationIntent.setFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP or Intent.FLAG_ACTIVITY_SINGLE_TOP)
        val pendingIntent = PendingIntent.getActivity(
            context,
            0,
            notificationIntent,
            PendingIntent.FLAG_IMMUTABLE
        )
        intent.action = STOPFOREGROUND_ACTION
        val servicePendingIntent = PendingIntent.getService(
            context, 0, intent,
            PendingIntent.FLAG_MUTABLE
        )


    val notificationBuilder: NotificationCompat.Builder =
        NotificationCompat.Builder(context, CLIENT_CHANNEL_ID)
            .setContentTitle(context.getString(R.string.app_name))
            //.setContentText("No client connected")
            .setShowWhen(false)
            .setSmallIcon(R.drawable.ic_baseline_devices_other_24)
            .setContentIntent(pendingIntent)
            .addAction(
                R.drawable.ic_baseline_devices_other_24, context.getString(R.string.stop_client),
                servicePendingIntent)


        val notificationManager =
            context.getSystemService(Context.NOTIFICATION_SERVICE) as NotificationManager
        return notificationBuilder
    }

    fun showNotification(context: Context, notificationBuilder: NotificationCompat.Builder, notificationID: Int){
        val notificationManager =
            context.getSystemService(Context.NOTIFICATION_SERVICE) as NotificationManager
        notificationManager.notify(notificationID, notificationBuilder.build());
    }
