package com.serialio.sdm_tcpip_client.utils

import com.serialio.sdm_tcpip_client.data.tcp_protocol.model_response_dto.ParametersResponseTcp

sealed class ServerResponse(val isSuccess: Boolean = false, val message: String? = null, val params: ParametersResponseTcp? = null){
    class ClientIdentification(isSuccess: Boolean = false, message: String? = null): ServerResponse(isSuccess = isSuccess, message = message)
    class PeripheralDeviceList(isSuccess: Boolean, message: String? = null, params: ParametersResponseTcp? = null): ServerResponse(isSuccess = isSuccess, message = message ,params)
    class PeripheralDeviceStatus( isSuccess: Boolean, message: String?, params: ParametersResponseTcp? = null): ServerResponse(isSuccess = isSuccess, message = message, params)
    class PeripheralDeviceCmdResponse(isSuccess: Boolean, message: String?): ServerResponse(isSuccess = isSuccess, message = message)
}
